Colour-graded Jitter in JavaScript

Using ApexCharts with JavaScript

This Colour-graded Jitter example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// ── Reproducible synthetic data (seeded PRNG, no network) ──────────────
function mulberry32(a) {
  return function () {
    a |= 0
    a = (a + 0x6d2b79f5) | 0
    var t = Math.imul(a ^ (a >>> 15), 1 | a)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}
var rng = mulberry32(1357924680)

function gauss(mean, sd) {
  var u = 0,
    v = 0
  while (u === 0) u = rng()
  while (v === 0) v = rng()
  return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
}

function sample(n, mean, sd) {
  var out = []
  for (var i = 0; i < n; i++) {
    out.push(Math.round(gauss(mean, sd) * 10) / 10)
  }
  return out
}

// Daily afternoon temperature (°C) across the year — each dot is one day,
// coloured by how warm it was (cool → warm along the ramp). [month, mean, sd]
// follow a seasonal arc, so the colour gradient sweeps low → high → low.
var MONTHS = [
  ['Jan', 4, 3],
  ['Feb', 6, 3],
  ['Mar', 11, 3.5],
  ['Apr', 15, 4],
  ['May', 20, 4],
  ['Jun', 24, 4],
  ['Jul', 27, 3.5],
  ['Aug', 26, 3.5],
  ['Sep', 21, 4],
  ['Oct', 15, 4.5],
  ['Nov', 9, 3.5],
  ['Dec', 5, 3],
].map(function (m) {
  return { name: m[0], data: sample(110, m[1], m[2]) }
})

// Gaussian KDE → [[value, density], ...]. The chart renders the profile you
// supply; the smoothness is a property of this bandwidth, computed here.
function kde(values, bw) {
  var min = Math.min.apply(null, values) - bw
  var max = Math.max.apply(null, values) + bw
  var N = values.length
  var profile = []
  for (var x = min; x <= max; x += 0.4) {
    var sum = 0
    for (var k = 0; k < N; k++) {
      var d = (x - values[k]) / bw
      sum += Math.exp(-0.5 * d * d)
    }
    profile.push([Math.round(x * 100) / 100, sum / (N * bw)])
  }
  return profile
}

// A sequential cool→warm colour ramp (low → high).
var COLOR_RAMP = ['#2c7bb6', '#abd9e9', '#ffffbf', '#fdae61', '#d7191c']

var options = {
  series: [
    {
      name: 'Temperature',
      data: MONTHS.map(function (m) {
        return {
          x: m.name,
          y: { density: kde(m.data, 1.5), points: m.data },
        }
      }),
    },
  ],
  chart: {
    type: 'violin',
    height: 560,
  },
  title: {
    text: 'Afternoon temperature through the year — dots coloured by value',
  },
  // muted grey violins so the colour-graded dots are the focus
  colors: ['#b8c4cc'],
  stroke: { width: 1, colors: ['#90a4ae'] },
  fill: { opacity: 0.6 },
  legend: { show: false },
  yaxis: {
    title: { text: 'Temperature (°C)' },
  },
  plotOptions: {
    violin: {
      points: {
        show: true,
        size: 5,
        jitter: 0.8,
        opacity: 1,
        strokeColor: '#fff',
        strokeWidth: 1,
        // colour each observation by its value along the ramp
        colorScale: { colors: COLOR_RAMP, min: 0, max: 32 },
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Colour-graded Jitter in React

Using ApexCharts with React

This Colour-graded Jitter example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// ── Reproducible synthetic data (seeded PRNG, no network) ──────────────
function mulberry32(a) {
  return function () {
    a |= 0
    a = (a + 0x6d2b79f5) | 0
    var t = Math.imul(a ^ (a >>> 15), 1 | a)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}
var rng = mulberry32(1357924680)

function gauss(mean, sd) {
  var u = 0,
    v = 0
  while (u === 0) u = rng()
  while (v === 0) v = rng()
  return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
}

function sample(n, mean, sd) {
  var out = []
  for (var i = 0; i < n; i++) {
    out.push(Math.round(gauss(mean, sd) * 10) / 10)
  }
  return out
}

// Daily afternoon temperature (°C) across the year — each dot is one day,
// coloured by how warm it was (cool → warm along the ramp). [month, mean, sd]
// follow a seasonal arc, so the colour gradient sweeps low → high → low.
var MONTHS = [
  ['Jan', 4, 3],
  ['Feb', 6, 3],
  ['Mar', 11, 3.5],
  ['Apr', 15, 4],
  ['May', 20, 4],
  ['Jun', 24, 4],
  ['Jul', 27, 3.5],
  ['Aug', 26, 3.5],
  ['Sep', 21, 4],
  ['Oct', 15, 4.5],
  ['Nov', 9, 3.5],
  ['Dec', 5, 3],
].map(function (m) {
  return { name: m[0], data: sample(110, m[1], m[2]) }
})

// Gaussian KDE → [[value, density], ...]. The chart renders the profile you
// supply; the smoothness is a property of this bandwidth, computed here.
function kde(values, bw) {
  var min = Math.min.apply(null, values) - bw
  var max = Math.max.apply(null, values) + bw
  var N = values.length
  var profile = []
  for (var x = min; x <= max; x += 0.4) {
    var sum = 0
    for (var k = 0; k < N; k++) {
      var d = (x - values[k]) / bw
      sum += Math.exp(-0.5 * d * d)
    }
    profile.push([Math.round(x * 100) / 100, sum / (N * bw)])
  }
  return profile
}

// A sequential cool→warm colour ramp (low → high).
var COLOR_RAMP = ['#2c7bb6', '#abd9e9', '#ffffbf', '#fdae61', '#d7191c']

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Temperature',
        data: MONTHS.map(function (m) {
          return {
            x: m.name,
            y: { density: kde(m.data, 1.5), points: m.data },
          }
        }),
      },
    ],
    options: {
      chart: {
        type: 'violin',
        height: 560,
      },
      title: {
        text: 'Afternoon temperature through the year — dots coloured by value',
      },
      // muted grey violins so the colour-graded dots are the focus
      colors: ['#b8c4cc'],
      stroke: { width: 1, colors: ['#90a4ae'] },
      fill: { opacity: 0.6 },
      legend: { show: false },
      yaxis: {
        title: { text: 'Temperature (°C)' },
      },
      plotOptions: {
        violin: {
          points: {
            show: true,
            size: 5,
            jitter: 0.8,
            opacity: 1,
            strokeColor: '#fff',
            strokeWidth: 1,
            // colour each observation by its value along the ramp
            colorScale: { colors: COLOR_RAMP, min: 0, max: 32 },
          },
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="violin"
          height={560}
        />
      </div>
    </div>
  )
}

export default ApexChart

Colour-graded Jitter in Angular

Using ApexCharts with Angular

This Colour-graded Jitter example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (a: any): any => {
          return function () {
            a |= 0
            a = (a + 0x6d2b79f5) | 0
            var t = Math.imul(a ^ (a >>> 15), 1 | a)
            t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
            return ((t ^ (t >>> 14)) >>> 0) / 4294967296
          }
        };

  private rng: any = this.mulberry32(1357924680);

  private gauss = (mean: any, sd: any): any => {
          var u = 0,
            v = 0
          while (u === 0) u = this.rng()
          while (v === 0) v = this.rng()
          return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
        };

  private sample = (n: any, mean: any, sd: any): any => {
          var out = []
          for (var i = 0; i < n; i++) {
            out.push(Math.round(this.gauss(mean, sd) * 10) / 10)
          }
          return out
        };

  private MONTHS: any = [
          ['Jan', 4, 3],
          ['Feb', 6, 3],
          ['Mar', 11, 3.5],
          ['Apr', 15, 4],
          ['May', 20, 4],
          ['Jun', 24, 4],
          ['Jul', 27, 3.5],
          ['Aug', 26, 3.5],
          ['Sep', 21, 4],
          ['Oct', 15, 4.5],
          ['Nov', 9, 3.5],
          ['Dec', 5, 3],
        ].map(function (m) {
          return { name: m[0], data: this.sample(110, m[1], m[2]) }
        });

  private kde = (values: any, bw: any): any => {
          var min = Math.min.apply(null, values) - bw
          var max = Math.max.apply(null, values) + bw
          var N = values.length
          var profile = []
          for (var x = min; x <= max; x += 0.4) {
            var sum = 0
            for (var k = 0; k < N; k++) {
              var d = (x - values[k]) / bw
              sum += Math.exp(-0.5 * d * d)
            }
            profile.push([Math.round(x * 100) / 100, sum / (N * bw)])
          }
          return profile
        };

  private COLOR_RAMP: any = ['#2c7bb6', '#abd9e9', '#ffffbf', '#fdae61', '#d7191c'];

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Temperature',
              data: this.MONTHS.map(function (m) {
                return {
                  x: m.name,
                  y: { density: this.kde(m.data, 1.5), points: m.data },
                }
              }),
            },
          ],
          chart: {
            type: 'violin',
            height: 560,
          },
          title: {
            text: 'Afternoon temperature through the year — dots coloured by value',
          },
          // muted grey violins so the colour-graded dots are the focus
          colors: ['#b8c4cc'],
          stroke: { width: 1, colors: ['#90a4ae'] },
          fill: { opacity: 0.6 },
          legend: { show: false },
          yaxis: {
            title: { text: 'Temperature (°C)' },
          },
          plotOptions: {
            violin: {
              points: {
                show: true,
                size: 5,
                jitter: 0.8,
                opacity: 1,
                strokeColor: '#fff',
                strokeWidth: 1,
                // colour each observation by its value along the ramp
                colorScale: { colors: this.COLOR_RAMP, min: 0, max: 32 },
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Colour-graded Jitter in Vue

Using ApexCharts with Vue

This Colour-graded Jitter example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="violin"
        height="560"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// ── Reproducible synthetic data (seeded PRNG, no network) ──────────────
function mulberry32(a) {
  return function () {
    a |= 0
    a = (a + 0x6d2b79f5) | 0
    var t = Math.imul(a ^ (a >>> 15), 1 | a)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}
var rng = mulberry32(1357924680)

function gauss(mean, sd) {
  var u = 0,
    v = 0
  while (u === 0) u = rng()
  while (v === 0) v = rng()
  return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
}

function sample(n, mean, sd) {
  var out = []
  for (var i = 0; i < n; i++) {
    out.push(Math.round(gauss(mean, sd) * 10) / 10)
  }
  return out
}

// Daily afternoon temperature (°C) across the year — each dot is one day,
// coloured by how warm it was (cool → warm along the ramp). [month, mean, sd]
// follow a seasonal arc, so the colour gradient sweeps low → high → low.
var MONTHS = [
  ['Jan', 4, 3],
  ['Feb', 6, 3],
  ['Mar', 11, 3.5],
  ['Apr', 15, 4],
  ['May', 20, 4],
  ['Jun', 24, 4],
  ['Jul', 27, 3.5],
  ['Aug', 26, 3.5],
  ['Sep', 21, 4],
  ['Oct', 15, 4.5],
  ['Nov', 9, 3.5],
  ['Dec', 5, 3],
].map(function (m) {
  return { name: m[0], data: sample(110, m[1], m[2]) }
})

// Gaussian KDE → [[value, density], ...]. The chart renders the profile you
// supply; the smoothness is a property of this bandwidth, computed here.
function kde(values, bw) {
  var min = Math.min.apply(null, values) - bw
  var max = Math.max.apply(null, values) + bw
  var N = values.length
  var profile = []
  for (var x = min; x <= max; x += 0.4) {
    var sum = 0
    for (var k = 0; k < N; k++) {
      var d = (x - values[k]) / bw
      sum += Math.exp(-0.5 * d * d)
    }
    profile.push([Math.round(x * 100) / 100, sum / (N * bw)])
  }
  return profile
}

// A sequential cool→warm colour ramp (low → high).
var COLOR_RAMP = ['#2c7bb6', '#abd9e9', '#ffffbf', '#fdae61', '#d7191c']

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Temperature',
          data: MONTHS.map(function (m) {
            return {
              x: m.name,
              y: { density: kde(m.data, 1.5), points: m.data },
            }
          }),
        },
      ],
      chartOptions: {
        chart: {
          type: 'violin',
          height: 560,
        },
        title: {
          text: 'Afternoon temperature through the year — dots coloured by value',
        },
        // muted grey violins so the colour-graded dots are the focus
        colors: ['#b8c4cc'],
        stroke: { width: 1, colors: ['#90a4ae'] },
        fill: { opacity: 0.6 },
        legend: { show: false },
        yaxis: {
          title: { text: 'Temperature (°C)' },
        },
        plotOptions: {
          violin: {
            points: {
              show: true,
              size: 5,
              jitter: 0.8,
              opacity: 1,
              strokeColor: '#fff',
              strokeWidth: 1,
              // colour each observation by its value along the ramp
              colorScale: { colors: COLOR_RAMP, min: 0, max: 32 },
            },
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 920px;
  margin: 20px auto;
}
</style>